common.sh 4.3 KB
Newer Older
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19
#!/bin/bash

# Copyright 2016 The Kubernetes Authors All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.


# This script downloads the test files from the build bucket and makes some executable.

X
Xinbo Weng 已提交
20
# The script expects the following env variables:
21
# OS_ARCH: The operating system and the architecture separated by a hyphen '-' (e.g. darwin-amd64, linux-amd64, windows-amd64)
M
Matt Rickard 已提交
22 23 24
# VM_DRIVER: the vm-driver to use for the test
# EXTRA_BUILD_ARGS: additional flags to pass into minikube start
# JOB_NAME: the name of the logfile and check name to update on github
25 26 27 28 29


# Copy only the files we need to this workspace
mkdir -p out/ testdata/
gsutil cp gs://minikube-builds/${MINIKUBE_LOCATION}/minikube-${OS_ARCH} out/
M
Matt Rickard 已提交
30
gsutil cp gs://minikube-builds/${MINIKUBE_LOCATION}/localkube out/
D
dlorenc 已提交
31
gsutil cp gs://minikube-builds/${MINIKUBE_LOCATION}/docker-machine-driver-* out/
32 33
gsutil cp gs://minikube-builds/${MINIKUBE_LOCATION}/e2e-${OS_ARCH} out/
gsutil cp gs://minikube-builds/${MINIKUBE_LOCATION}/testdata/busybox.yaml testdata/
D
Dan Lorenc 已提交
34
gsutil cp gs://minikube-builds/${MINIKUBE_LOCATION}/testdata/pvc.yaml testdata/
35
gsutil cp gs://minikube-builds/${MINIKUBE_LOCATION}/testdata/busybox-mount-test.yaml testdata/
36
gsutil cp gs://minikube-builds/${MINIKUBE_LOCATION}/testdata/nginx-pod-svc.yaml testdata/
37
gsutil cp gs://minikube-builds/${MINIKUBE_LOCATION}/testdata/nginx-ing.yaml testdata/
38

D
dlorenc 已提交
39 40 41 42 43 44 45 46 47 48
# Set the executable bit on the e2e binary and out binary
chmod +x out/e2e-${OS_ARCH}
chmod +x out/minikube-${OS_ARCH}
chmod +x out/docker-machine-driver-*
chmod +x out/localkube

# Fix permissions in $HOME
sudo chown -R $USER $HOME/.kube
sudo chown -R $USER $HOME/.minikube

M
Matt Rickard 已提交
49 50 51 52
export MINIKUBE_WANTREPORTERRORPROMPT=False
sudo ./out/minikube-${OS_ARCH} delete || true
./out/minikube-${OS_ARCH} delete || true

D
dlorenc 已提交
53
# Add the out/ directory to the PATH, for using new drivers.
D
dlorenc 已提交
54
export PATH="$(pwd)/out/":$PATH
D
dlorenc 已提交
55

56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71
# Linux cleanup
virsh -c qemu:///system list --all \
      | sed -n '3,$ p' \
      | cut -d' ' -f 7 \
      | xargs -I {} sh -c "virsh -c qemu:///system destroy {}; virsh -c qemu:///system undefine {}"  \
      || true

# Clean up virtualbox VMs
vboxmanage list vms \
      | cut -d "{" -f2 \
      | cut -d "}" -f1 \
      | xargs -I {} sh -c "vboxmanage unregistervm {} --delete" \
      || true

# Clean up xhyve disks
hdiutil info \
72 73
      | egrep \/dev\/disk[1-9][^s] \
      | awk '{print $1}' \
74 75 76 77 78 79
      | xargs -I {} sh -c "hdiutil detach {}" \
      || true

# Clean up xhyve processes
pgrep xhyve | xargs kill || true

D
dlorenc 已提交
80 81 82 83 84

if [ -e out/docker-machine-driver-hyperkit ]; then
  sudo chown root:wheel out/docker-machine-driver-hyperkit || true
  sudo chmod u+s out/docker-machine-driver-hyperkit || true
fi
M
Matt Rickard 已提交
85

86 87 88
# See the default image
./out/minikube-${OS_ARCH} start -h | grep iso

M
Matt Rickard 已提交
89 90
# see what driver we are using
which docker-machine-driver-${VM_DRIVER} || true
M
Matt Rickard 已提交
91
find ~/.minikube || true
M
Matt Rickard 已提交
92

M
Matt Rickard 已提交
93 94
# Allow this to fail, we'll switch on the return code below.
set +e
95
${SUDO_PREFIX}out/e2e-${OS_ARCH} -minikube-start-args="--vm-driver=${VM_DRIVER} ${EXTRA_START_ARGS}" -minikube-args="--v=10 --logtostderr ${EXTRA_ARGS}" -test.v -test.timeout=30m -binary=out/minikube-${OS_ARCH}
M
Matt Rickard 已提交
96 97 98
result=$?
set -e

D
dlorenc 已提交
99 100 101
# See the KUBECONFIG file for debugging
sudo cat $KUBECONFIG

102 103 104 105
MINIKUBE_WANTREPORTERRORPROMPT=False sudo ./out/minikube-${OS_ARCH} delete \
|| MINIKUBE_WANTREPORTERRORPROMPT=False ./out/minikube-${OS_ARCH} delete \
|| true

M
Matt Rickard 已提交
106 107 108 109
if [[ $result -eq 0 ]]; then
  status="success"
else
  status="failure"
110
  source print-debug-info.sh
M
Matt Rickard 已提交
111 112 113 114 115 116 117 118 119 120
fi

set +x
target_url="https://storage.googleapis.com/minikube-builds/logs/${MINIKUBE_LOCATION}/${JOB_NAME}.txt"
curl "https://api.github.com/repos/kubernetes/minikube/statuses/${COMMIT}?access_token=$access_token" \
  -H "Content-Type: application/json" \
  -X POST \
  -d "{\"state\": \"$status\", \"description\": \"Jenkins\", \"target_url\": \"$target_url\", \"context\": \"${JOB_NAME}\"}"
set -x

121
exit $result